REM
REM  Z80 Timer emulation
REM  This file is part of the ZilogBoy project.
REM  Copyright (C) Mateusz Viste 2010
REM

REM FF05 - TIMA - Timer counter (R/W)
REM        This timer is incremented by a clock frequency
REM        specified by the TAC register ($FF07). When the
REM        value overflows (gets bigger than FFh) then it
REM        will be reset to the value specified in TMA
REM        (FF06), and an interrupt will be requested.

DIM SHARED TimerC AS UINTEGER     ' Timer counter

SUB uTimer(cycles AS UINTEGER)           ' Timer Emulation
  If MemoryRead(&hFF07) AND 4 THEN   ' tac bit 2
    TimerC += cycles
    SELECT CASE MemoryRead(&hFF07) AND 3
      CASE 0
        IF TimerC > 1023 THEN
          TimerC -= 1024
          IF MemoryRead(&hFF05) = 255 THEN
              MemoryWrite(&hFF05, MemoryRead(&hFF06))
              MemoryWrite(&hFF0F, MemoryRead(&hFF0F) OR 4)  ' IF
            ELSE
              MemoryWrite(&hFF05, MemoryRead(&hFF05) + 1)
          END IF
        END IF
      CASE 1
        IF TimerC > 15 THEN
          TimerC -= 16
          IF MemoryRead(&hFF05) = 255 THEN
              MemoryWrite(&hFF05, MemoryRead(&hFF06))
              MemoryWrite(&hFF0F, MemoryRead(&hFF0F) OR 4)  ' IF
            ELSE
              MemoryWrite(&hFF05, MemoryRead(&hFF05) + 1)
          END IF
        END IF
      CASE 2
        IF TimerC > 63 THEN
          TimerC -= 64
          IF MemoryRead(&hFF05) = 255 THEN
              MemoryWrite(&hFF05, MemoryRead(&hFF06))
              MemoryWrite(&hFF0F, MemoryRead(&hFF0F) OR 4)  ' IF
            ELSE
              MemoryWrite(&hFF05, MemoryRead(&hFF05) + 1)
          END IF
        END IF
      CASE 3
        IF TimerC > 255 THEN
          TimerC -= 256
          IF MemoryRead(&hFF05) = 255 THEN
              MemoryWrite(&hFF05, MemoryRead(&hFF06))
              MemoryWrite(&hFF0F, MemoryRead(&hFF0F) OR 4)  ' IF
            ELSE
              MemoryWrite(&hFF05, MemoryRead(&hFF05) + 1)
          END IF
        END IF
    END SELECT
  END IF
END SUB
